Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class Id

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.Id

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, Locator

    public class Id

extends SystemFunction

The XPath id() or element-with-id() function XPath 2.0 version: accepts any sequence as the first parameter; each item in the sequence is taken as an IDREFS value, that is, a space-separated list of ID values. Also accepts an optional second argument to identify the target document, this defaults to the context node.

See Also:
  Serialized Form

Field Summary
`static int` | `ELEMENT_WITH_ID`
`static int` | `ID`

Fields inherited from class net.sf.saxon.functions.SystemFunction
`operation`

Fields inherited from class net.sf.saxon.expr.FunctionCall
`argument`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`Id()`

Method Summary
`PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of a doc() call or similar function to a PathMap.
`void` | `checkArguments(ExpressionVisitor visitor)` Static analysis: prevent sorting of the argument
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`static SequenceIterator` | `getIdMultiple(DocumentInfo doc, SequenceIterator idrefs)` Get an iterator over the nodes that have an id equal to one of the values is a set of whitespace separated strings.
`static SequenceIterator` | `getIdMultiple(DocumentInfo doc, SequenceIterator idrefs, int operation)` Get an iterator over the nodes that have an id equal to one of the values is a set of whitespace separated strings
`static SequenceIterator` | `getIdSingle(DocumentInfo doc, String idrefs)` 2-argument version of getIdSingle, retained to support Java code compiled using Saxon 9.1.
`static SequenceIterator` | `getIdSingle(DocumentInfo doc, String idrefs, int operation)` Get an iterator over the nodes that have an id equal to one of the values is a whitespace separated string
`SequenceIterator` | `iterate(XPathContext context)` Evaluate the function to return an iteration of selected nodes.
`Expression` | `preEvaluate(ExpressionVisitor visitor)` preEvaluate: this method suppresses compile-time evaluation by doing nothing
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify: add a second implicit argument, the context document
`Expression` | `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression.

Methods inherited from class net.sf.saxon.functions.SystemFunction
`addContextDocumentArgument, addDocToPathMap, computeCardinality, copy, getDetails, getErrorCodeForTypeErrors, getImplementationMethod, getItemType, getRequiredType, makeSystemFunction, optimize, setDetails, useContextItemAsDefault`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`addExternalFunctionCallToPathMap, checkArgumentCount, equals, explain, getArguments, getDisplayName, getExpressionName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, promote, replaceSubExpression, setArguments, setFunctionName, simplifyArguments, toString`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ID

    public static final int ID

See Also:
  Constant Field Values

### ELEMENT_WITH_ID

    public static final int ELEMENT_WITH_ID

See Also:
  Constant Field Values

Constructor Detail

### Id

    public Id()

Method Detail

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify: add a second implicit argument, the context document

  Overrides:
    `simplify` in class `FunctionCall`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression. This also calls preEvaluate() to evaluate the function if all the arguments are constant; functions that do not require this behavior can override the preEvaluate method.

  Overrides:
    `typeCheck` in class `FunctionCall`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### checkArguments

    public void checkArguments(ExpressionVisitor visitor)
                        throws XPathException

  Static analysis: prevent sorting of the argument

  Overrides:
    `checkArguments` in class `SystemFunction`
  Parameters:
    `visitor` - the expression visitor
  Throws:
    `XPathException`

### preEvaluate

    public Expression preEvaluate(ExpressionVisitor visitor)

  preEvaluate: this method suppresses compile-time evaluation by doing nothing

  Overrides:
    `preEvaluate` in class `FunctionCall`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the result of the early evaluation, or the original expression, or potentially a simplified expression

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `SystemFunction`
  Returns:
    the special properties, as a bit-significant integer

### addToPathMap

    public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                               PathMap.PathMapNodeSet pathMapNodeSet)

  Add a representation of a doc() call or similar function to a PathMap. This is a convenience method called by the addToPathMap() methods for doc(), document(), collection() and similar functions. These all create a new root expression in the path map.

  Overrides:
    `addToPathMap` in class `Expression`
  Parameters:
    `pathMap` - the PathMap to which the expression should be added
    `pathMapNodeSet` -
  Returns:
    the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the function to return an iteration of selected nodes.

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getIdSingle

    public static SequenceIterator getIdSingle(DocumentInfo doc,
                                               String idrefs,
                                               int operation)
                                        throws XPathException

  Get an iterator over the nodes that have an id equal to one of the values is a whitespace separated string

  Parameters:
    `doc` - The document to be searched
    `idrefs` - a string containing zero or more whitespace-separated ID values to be found in the document
    `operation` - either `ID` or `ELEMENT_WITH_ID`
  Returns:
    an iterator over the nodes whose ID is one of the specified values
  Throws:
    `XPathException`

### getIdSingle

    public static SequenceIterator getIdSingle(DocumentInfo doc,
                                               String idrefs)
                                        throws XPathException

  2-argument version of getIdSingle, retained to support Java code compiled using Saxon 9.1. Operation defaults to ID.

  Parameters:
    `doc` - The document to be searched
    `idrefs` - a string containing zero or more whitespace-separated ID values to be found in the document
  Returns:
    an iterator over the nodes whose ID is one of the specified values
  Throws:
    `XPathException`

### getIdMultiple

    public static SequenceIterator getIdMultiple(DocumentInfo doc,
                                                 SequenceIterator idrefs,
                                                 int operation)
                                          throws XPathException

  Get an iterator over the nodes that have an id equal to one of the values is a set of whitespace separated strings

  Parameters:
    `doc` - The document to be searched
    `idrefs` - an iterator over a set of strings each of which is a string containing zero or more whitespace-separated ID values to be found in the document
  Returns:
    an iterator over the nodes whose ID is one of the specified values
  Throws:
    `XPathException`

### getIdMultiple

    public static SequenceIterator getIdMultiple(DocumentInfo doc,
                                                 SequenceIterator idrefs)
                                          throws XPathException

  Get an iterator over the nodes that have an id equal to one of the values is a set of whitespace separated strings. 2-argument version retained to support Java code compiled under Saxon 9.1

  Parameters:
    `doc` - The document to be searched
    `idrefs` - an iterator over a set of strings each of which is a string containing zero or more whitespace-separated ID values to be found in the document
  Returns:
    an iterator over the nodes whose ID is one of the specified values
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.